diff -durpN psqlodbc-09.01.0200.orig/environ.c psqlodbc-09.01.0200/environ.c
--- psqlodbc-09.01.0200.orig/environ.c	2010-08-21 08:29:19.000000000 +0200
+++ psqlodbc-09.01.0200/environ.c	2012-08-31 12:50:53.877651778 +0200
@@ -226,7 +226,17 @@ ER_ReturnError(PG_ErrorInfo **pgerror,
 	}
 	stapos = (RecNumber - 1) * error->recsize;
 	if (stapos > msglen)
+	{
+		if (clear_str)
+		{
+			if (error->errorpos >= msglen)
+			{
+				ER_Destructor(error);
+				*pgerror = NULL;
+			}
+		}
 		return SQL_NO_DATA_FOUND; 
+	}
 	pcblen = wrtlen = msglen - stapos;
 	if (pcblen > error->recsize)
 		pcblen = error->recsize;
@@ -259,15 +269,9 @@ ER_ReturnError(PG_ErrorInfo **pgerror,
 		strncpy_null(szSqlState, error->sqlstate, 6);
 
 	mylog("	     szSqlState = '%s',len=%d, szError='%s'\n", szSqlState, pcblen, szErrorMsg);
-	if (clear_str)
-	{
-		error->errorpos = stapos + wrtlen;
-		if (error->errorpos >= msglen)
-		{
-			ER_Destructor(error);
-			*pgerror = NULL;
-		}
-	}
+
+	error->errorpos = stapos + wrtlen;
+
 	if (wrtlen == 0)
 		return SQL_SUCCESS_WITH_INFO;
 	else
